/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package demo.hello;

abstract public class HelloExceptionHelper {
    private static String _id = "IDL:demo/hello/HelloException:1.0";

    public static void insert(org.omg.CORBA.Any a, HelloException t) {
        org.omg.CORBA.portable.OutputStream out = a.create_output_stream();
        a.type(type());
        write(out, t);
        a.read_value(out.create_input_stream(), type());
    }

    public static HelloException extract(org.omg.CORBA.Any a) {
        return read(a.create_input_stream());
    }

    private static org.omg.CORBA.TypeCode __typeCode = null;
    private static boolean __active = false;

    public static org.omg.CORBA.TypeCode type() {
        if (__typeCode == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (__typeCode == null) {
                    if (__active) {
                        return org.omg.CORBA.ORB.init().create_recursive_tc(_id);
                    }
                    __active = true;
                    org.omg.CORBA.StructMember[] _members0 = new org.omg.CORBA.StructMember[0];
                    org.omg.CORBA.TypeCode _tcOf_members0 = null;
                    __typeCode = org.omg.CORBA.ORB.init().create_exception_tc(demo.hello.HelloExceptionHelper.id(),
                        "HelloException", _members0);
                    __active = false;
                }
            }
        }
        return __typeCode;
    }

    public static String id() {
        return _id;
    }

    public static HelloException read(org.omg.CORBA.portable.InputStream is) {
        demo.hello.HelloException value = new demo.hello.HelloException();
        is.read_string();
        return value;
    }

    public static void write(org.omg.CORBA.portable.OutputStream os, HelloException val) {
        os.write_string(id());
    }

    public static HelloException narrow(org.omg.CORBA.Object obj) {
        //what to do?
        return null;
    }
}
