/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package demo.hello;

public class HelloObjHolder implements org.omg.CORBA.portable.Streamable {
    public HelloObj value = null;

    public HelloObjHolder() {
    }

    public HelloObjHolder(HelloObj initial) {
        value = initial;
    }

    public void _read(org.omg.CORBA.portable.InputStream is) {
        value = demo.hello.HelloObjHelper.read(is);
    }

    public void _write(org.omg.CORBA.portable.OutputStream os) {
        demo.hello.HelloObjHelper.write(os, value);
    }

    public org.omg.CORBA.TypeCode _type() {
        return demo.hello.HelloObjHelper.type();
    }
}
