/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package demo.hello;

import org.omg.CORBA.portable.*;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.Servant;

abstract public class HelloObjPOA extends Servant implements HelloObjOperations, InvokeHandler {
    public HelloObj _this() {
        return HelloObjHelper.narrow(super._this_object());
    }

    public HelloObj _this(org.omg.CORBA.ORB orb) {
        return HelloObjHelper.narrow(super._this_object(orb));
    }

    public java.lang.String[] _all_interfaces(org.omg.PortableServer.POA poa, byte[] objectId) {
        return __ids;
    }

    private static java.lang.String[] __ids = {
		"IDL:demo/hello/HelloObj:1.0"
	};

    public org.omg.CORBA.portable.OutputStream
        _invoke(java.lang.String opName, org.omg.CORBA.portable.InputStream is,
        org.omg.CORBA.portable.ResponseHandler handler) {
            org.omg.CORBA.portable.OutputStream _output = null;
            if ("getHelloString".equals(opName)) {
                try {
                    java.lang.String s;
                    s = is.read_string();
                    java.lang.String _result = this.getHelloString(s);
                    _output = handler.createReply();
                    _output.write_string(_result);
                }
                catch (HelloException _exception) {
                    _output = handler.createExceptionReply();
                    HelloExceptionHelper.write(_output, _exception);
                }
                return _output;
            }
            else {
                throw new org.omg.CORBA.BAD_OPERATION();
            }
    }
}
