/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb;

import org.omg.IOP.*;
import org.omg.GIOP.*;
import org.huihoo.orbas.orb.protocols.Transport;
import org.huihoo.orbas.orb.cdr.*;

public interface ClientWorker {

    public void invokeOneway(org.omg.CORBA.portable.OutputStream os);
    
    public CDRInputStream invoke(org.omg.CORBA.portable.OutputStream os)throws 
        org.omg.CORBA.portable.ApplicationException,
        org.omg.CORBA.portable.RemarshalException;
    
    public CDROutputStream createRequest(org.huihoo.orbas.orb.protocols.TargetAddress target,
                                         org.omg.GIOP.TargetAddress targetObject,
                                         String operation,
                                         boolean responseExpected);

    public CDROutputStream createLocateRequest(org.huihoo.orbas.orb.protocols.TargetAddress target);
}