/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols;

public abstract class Channel implements java.lang.Runnable{
    
    public Channel() {
        
    }
    
    public abstract int getProtocolTag();
    
    public abstract TargetAddress getTargetAddress();
    
    public abstract void setTargetAddress(TargetAddress a);
    
    public abstract Transport setup();
    
    public abstract void teardown();
    
    public abstract void run();
    
    public abstract Transport accept();
    
}