/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols;

import org.huihoo.orbas.orb.cdr.*;

public abstract class ProfileCreator {
    protected CDROutputStream out;
//    protected byte[] objectKey;
    
    public ProfileCreator(CDROutputStream out) {
        this.out = out;
    }
    
    public ProfileCreator() {
        
    }
    
    public void setOutputStream(CDROutputStream out) {
        this.out = out;
    }
    
//    public void setObjectKey(byte[] objectKey) {
//        this.objectKey = objectKey;
//    }
    
    public abstract Channel createChannel();
    
    public abstract org.omg.IOP.TaggedProfile[] createProfiles(byte[] objectKey, int version);
}