/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols;

import org.huihoo.orbas.orb.cdr.*;

public abstract class ProfileExtractor {
    
    protected CDRInputStream in;
    
    public ProfileExtractor(CDRInputStream in) {
        this.in = in;
    }
    
    public ProfileExtractor() {
        
    }
    
    public abstract TargetAddress getTargetAddress();
    
    public abstract byte[] getObjectKey();
    
    public void setInputStream(CDRInputStream in) {
        this.in = in;
    }
    
    public abstract void parse();
}