/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.typecode;

public abstract class TypeCodeBase extends org.omg.CORBA.TypeCode {
    
    public boolean equivalent(org.omg.CORBA.TypeCode tc) {
        
        TypeCodeAlias tc1 = (TypeCodeAlias)tc;
        
        if( tc.kind() == org.omg.CORBA.TCKind.tk_alias ) {
            
            try {
                org.omg.CORBA.TypeCode newTc = tc1.content_type();
                return equivalent(newTc);
            }
            catch(org.omg.CORBA.TypeCodePackage.BadKind ex) {
                return false;
            }
        }
        
        if( tc.kind() != kind() ) {
            return false;
        }
        
        if( kind() == org.omg.CORBA.TCKind.tk_alias ) {
            try {
                org.omg.CORBA.TypeCode newTc = tc1.content_type();
                return newTc.equivalent(tc);
            }
            catch(org.omg.CORBA.TypeCodePackage.BadKind ex) {
                return false;
            }
        }
        
        return equal(tc);
    }
}