/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package demo.hello;

abstract public class HelloObjHelper {
    private static String _id = "IDL:demo/hello/HelloObj:1.0";

    public static void insert(org.omg.CORBA.Any a, HelloObj t) {
        org.omg.CORBA.portable.OutputStream out = a.create_output_stream();
        a.type(type());
        write(out, t);
        a.read_value(out.create_input_stream(), type());
    }

    public static HelloObj extract(org.omg.CORBA.Any a) {
        return read(a.create_input_stream());
    }

    private static org.omg.CORBA.TypeCode __typeCode = null;

    public static org.omg.CORBA.TypeCode type() {
        if (__typeCode == null) {
            __typeCode = org.omg.CORBA.ORB.init().create_interface_tc(demo.hello.HelloObjHelper.id(), "HelloObj");
        }
        return __typeCode;
    }

    public static String id() {
        return _id;
    }

    public static HelloObj read(org.omg.CORBA.portable.InputStream is) {
        return narrow(is.read_Object(_HelloObjStub.class));
    }

    public static void write(org.omg.CORBA.portable.OutputStream os, HelloObj value) {
        os.write_Object((org.omg.CORBA.Object) value);
    }

    public static HelloObj narrow(org.omg.CORBA.Object obj) {
        if (obj == null)
            return null;
        else if (obj instanceof demo.hello.HelloObj)
            return (demo.hello.HelloObj) obj;
        else if (!obj._is_a(id()))
            throw new org.omg.CORBA.BAD_PARAM();
        else {
            org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate();
            demo.hello._HelloObjStub stub = new demo.hello._HelloObjStub();
            stub._set_delegate(delegate);
            return stub;
        }
    }
}
