/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package demo.hello;

public class _HelloObjStub extends org.omg.CORBA.portable.ObjectImpl implements HelloObj {
    public java.lang.String[] _ids() {
        return __ids;
    }

    private static java.lang.String[] __ids =
        {
		"IDL:demo/hello/HelloObj:1.0"
	};
    final public static java.lang.Class _opsClass = demo.hello.HelloObj.class;

    public java.lang.String getHelloString(java.lang.String helloString) throws demo.hello.HelloException {
        while (true) {
            if (!this._is_local()) {
                org.omg.CORBA.portable.OutputStream _output = null;
                org.omg.CORBA.portable.InputStream _input = null;
                try {
                    _output = this._request("getHelloString", true);
                    _output.write_string(helloString);
                    _input = this._invoke(_output);
                    return _input.read_string();
                }
                catch (org.omg.CORBA.portable.RemarshalException _exception) {
                    continue;
                }
                catch (org.omg.CORBA.portable.ApplicationException _exception) {
                    java.lang.String _exception_id = _exception.getId();
                    if (_exception_id.equals(HelloExceptionHelper.id())) {
                        _input = _exception.getInputStream();
                        throw HelloExceptionHelper.read(_input);
                    }
                    throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
                }
                finally {
                    this._releaseReply(_input);
                }
            }
            else {
                org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getHelloString", _opsClass);
                if (_so == null)
                    continue;
                HelloObjOperations _self = (HelloObjOperations)_so.servant;
                try {
                    String result = _self.getHelloString(helloString);
                    if (_so instanceof org.omg.CORBA.portable.ServantObjectExt)
                        ((org.omg.CORBA.portable.ServantObjectExt) _so).normalCompletion();
                    return result;
                }
                catch (HelloException exc) {
                    if (_so instanceof org.omg.CORBA.portable.ServantObjectExt)
                        ((org.omg.CORBA.portable.ServantObjectExt) _so).exceptionalCompletion(exc);
                    throw exc;
                }
                catch (RuntimeException re) {
                    if (_so instanceof org.omg.CORBA.portable.ServantObjectExt)
                        ((org.omg.CORBA.portable.ServantObjectExt) _so).exceptionalCompletion(re);
                    throw re;
                }
                catch (Error err) {
                    if (_so instanceof org.omg.CORBA.portable.ServantObjectExt)
                        ((org.omg.CORBA.portable.ServantObjectExt) _so).exceptionalCompletion(err);
                    throw err;
                }
                finally {
                    _servant_postinvoke(_so);
                }
            }
        }
    }
}
