/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb;

import org.omg.IOP.*;
import org.omg.GIOP.*;
import org.huihoo.orbas.orb.protocols.Transport;
import org.huihoo.orbas.orb.cdr.*;

public abstract class Worker {
    
    public abstract Transport getTransport();
    
    public abstract CDRInputStream read() throws java.io.IOException,
        org.omg.CORBA.portable.ApplicationException,
        org.omg.CORBA.portable.RemarshalException;
    
    public abstract void write(org.omg.CORBA.portable.OutputStream out) throws java.io.IOException;
    
}