/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.ior;

import org.huihoo.orbas.orb.*;
import org.omg.IOP.*;

public class BytedIor {
    private ORB orb;
    private TaggedProfile[] profiles;
    private String typeID;
    private String s;
    private byte[] ior;
    private org.omg.CORBA.Object obj;

    public BytedIor(ORB orb, byte[] ior) {
        this.orb = orb;
        this.ior = ior;
    }

    public String getTypeId() {
        return this.typeID;
    }

    public TaggedProfile[] getProfiles() {
        return this.profiles;
    }

    public org.omg.CORBA.Object getObject() {
        return this.obj;
    }

    public byte[] getBytes() {
        return this.ior;
    }

    public String toString() {
        return this.s;
    }

    public boolean isA(String ID) {
        return ID.equals(typeID);
    }
}
