/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols;

public class ProfileRegistry {
    
    java.util.Hashtable extractors;
    java.util.Hashtable creators;
    
    public ProfileRegistry() {
        extractors = new java.util.Hashtable();
        creators = new java.util.Hashtable();
    }
    
    public void registerProfileDealer(int tag, ProfileCreator creator, ProfileExtractor extractor) {
        creators.put(new Integer(tag), creator);
        extractors.put(new Integer(tag), extractor);
    }
    
    public ProfileExtractor getProfileExtractor(int tag) {
        return (ProfileExtractor)extractors.get(new Integer(tag));
    }
    
    public ProfileCreator getProfileCreator(int tag) {
        return (ProfileCreator)creators.get(new Integer(tag));
    }
}