/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols;

public abstract class Transport {
    
    
    public abstract int getProtocolTag();
    
    public abstract TargetAddress getTargetAddress();
    
    public abstract java.io.InputStream getInputStream();
    
    public abstract java.io.OutputStream getOutputStream();
    
    public abstract void teardown(boolean wait);
    
}