package org.omg.GIOP;

//
// Helper class for : CancelRequestHeader
//
// @author OpenORB Compiler
//
public class CancelRequestHeaderHelper
{

	//
	// Insert CancelRequestHeader into an any
	// @param	a an any
	// @param	t CancelRequestHeader value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.GIOP.CancelRequestHeader t )
	{
		a.insert_Streamable( new org.omg.GIOP.CancelRequestHeaderHolder( t ));
	}

	//
	// Extract CancelRequestHeader from an any
	// @param	a an any
	// @return the extracted CancelRequestHeader value
	//
	public static org.omg.GIOP.CancelRequestHeader extract( org.omg.CORBA.Any a )
	{

		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the CancelRequestHeader TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[1];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "request_id";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
				_tc = orb.create_struct_tc(id(),"CancelRequestHeader",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the CancelRequestHeader IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/GIOP/CancelRequestHeader:1.0";

	//
	// Read CancelRequestHeader from a marshalled stream
	// @param	istream the input stream
	// @return the readed CancelRequestHeader value
	//
	public static org.omg.GIOP.CancelRequestHeader read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.GIOP.CancelRequestHeader new_one = new org.omg.GIOP.CancelRequestHeader();

		new_one.request_id = istream.read_ulong();

		return new_one;
	}

	//
	// Write CancelRequestHeader into a marshalled stream
	// @param	ostream the output stream
	// @param	value CancelRequestHeader value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.GIOP.CancelRequestHeader value )
	{
		ostream.write_ulong(value.request_id);
	}

}
