package org.omg.GIOP;

//
// Helper class for : RequestHeader_1_1
//
// @author OpenORB Compiler
//
public class RequestHeader_1_1Helper
{

	//
	// Insert RequestHeader_1_1 into an any
	// @param	a an any
	// @param	t RequestHeader_1_1 value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.GIOP.RequestHeader_1_1 t )
	{
		a.insert_Streamable( new org.omg.GIOP.RequestHeader_1_1Holder( t ));
	}

	//
	// Extract RequestHeader_1_1 from an any
	// @param	a an any
	// @return the extracted RequestHeader_1_1 value
	//
	public static org.omg.GIOP.RequestHeader_1_1 extract( org.omg.CORBA.Any a )
	{
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the RequestHeader_1_1 TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[7];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "service_context";
				_members[0].type = org.omg.IOP.ServiceContextListHelper.type();
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "request_id";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "response_expected";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "reserved";
				_members[3].type = org.omg.GIOP.OctetSeq3Helper.type();
				_members[4] = new org.omg.CORBA.StructMember();
				_members[4].name = "object_key";
				_members[4].type = org.omg.GIOP.OctetSeqHelper.type();
				_members[5] = new org.omg.CORBA.StructMember();
				_members[5].name = "operation";
				_members[5].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[6] = new org.omg.CORBA.StructMember();
				_members[6].name = "requesting_principal";
				_members[6].type = org.omg.GIOP.PrincipalHelper.type();
				_tc = orb.create_struct_tc(id(),"RequestHeader_1_1",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the RequestHeader_1_1 IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/GIOP/RequestHeader_1_1:1.0";

	//
	// Read RequestHeader_1_1 from a marshalled stream
	// @param	istream the input stream
	// @return the readed RequestHeader_1_1 value
	//
	public static org.omg.GIOP.RequestHeader_1_1 read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.GIOP.RequestHeader_1_1 new_one = new org.omg.GIOP.RequestHeader_1_1();

		new_one.service_context = org.omg.IOP.ServiceContextListHelper.read(istream);
		new_one.request_id = istream.read_ulong();
		new_one.response_expected = istream.read_boolean();
		new_one.reserved = org.omg.GIOP.OctetSeq3Helper.read(istream);
		new_one.object_key = org.omg.GIOP.OctetSeqHelper.read(istream);
		new_one.operation = istream.read_string();
		new_one.requesting_principal = org.omg.GIOP.PrincipalHelper.read(istream);

		return new_one;
	}

	//
	// Write RequestHeader_1_1 into a marshalled stream
	// @param	ostream the output stream
	// @param	value RequestHeader_1_1 value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.GIOP.RequestHeader_1_1 value )
	{
		org.omg.IOP.ServiceContextListHelper.write(ostream,value.service_context);
		ostream.write_ulong(value.request_id);
		ostream.write_boolean(value.response_expected);
		org.omg.GIOP.OctetSeq3Helper.write(ostream,value.reserved);
		org.omg.GIOP.OctetSeqHelper.write(ostream,value.object_key);
		ostream.write_string(value.operation);
		org.omg.GIOP.PrincipalHelper.write(ostream,value.requesting_principal);
	}

}
