package org.omg.GIOP;

//
// Helper class for : RequestHeader_1_2
//
// @author OpenORB Compiler
//
public class RequestHeader_1_2Helper
{

	//
	// Insert RequestHeader_1_2 into an any
	// @param	a an any
	// @param	t RequestHeader_1_2 value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.GIOP.RequestHeader_1_2 t )
	{
		a.insert_Streamable( new org.omg.GIOP.RequestHeader_1_2Holder( t ));
	}

	//
	// Extract RequestHeader_1_2 from an any
	// @param	a an any
	// @return the extracted RequestHeader_1_2 value
	//
	public static org.omg.GIOP.RequestHeader_1_2 extract( org.omg.CORBA.Any a )
	{

		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the RequestHeader_1_2 TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[6];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "request_id";
				_members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "response_flags";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "reserved";
				_members[2].type = org.omg.GIOP.OctetSeq3Helper.type();
				_members[3] = new org.omg.CORBA.StructMember();
				_members[3].name = "target";
				_members[3].type = org.omg.GIOP.TargetAddressHelper.type();
				_members[4] = new org.omg.CORBA.StructMember();
				_members[4].name = "operation";
				_members[4].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[5] = new org.omg.CORBA.StructMember();
				_members[5].name = "service_context";
				_members[5].type = org.omg.IOP.ServiceContextListHelper.type();
				_tc = orb.create_struct_tc(id(),"RequestHeader_1_2",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the RequestHeader_1_2 IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/GIOP/RequestHeader_1_2:1.0";

	//
	// Read RequestHeader_1_2 from a marshalled stream
	// @param	istream the input stream
	// @return the readed RequestHeader_1_2 value
	//
	public static org.omg.GIOP.RequestHeader_1_2 read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.GIOP.RequestHeader_1_2 new_one = new org.omg.GIOP.RequestHeader_1_2();

		new_one.request_id = istream.read_ulong();
		new_one.response_flags = istream.read_octet();
		new_one.reserved = org.omg.GIOP.OctetSeq3Helper.read(istream);
		new_one.target = org.omg.GIOP.TargetAddressHelper.read(istream);
		new_one.operation = istream.read_string();
		new_one.service_context = org.omg.IOP.ServiceContextListHelper.read(istream);

		return new_one;
	}

	//
	// Write RequestHeader_1_2 into a marshalled stream
	// @param	ostream the output stream
	// @param	value RequestHeader_1_2 value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.GIOP.RequestHeader_1_2 value )
	{
		ostream.write_ulong(value.request_id);
		ostream.write_octet(value.response_flags);
		org.omg.GIOP.OctetSeq3Helper.write(ostream,value.reserved);
		org.omg.GIOP.TargetAddressHelper.write(ostream,value.target);
		ostream.write_string(value.operation);
		org.omg.IOP.ServiceContextListHelper.write(ostream,value.service_context);
	}

}
