package org.omg.GIOP;

//
// Helper class for : SystemExceptionReplyBody
//
// @author OpenORB Compiler
//
public class SystemExceptionReplyBodyHelper
{
	//
	// Insert SystemExceptionReplyBody into an any
	// @param	a an any
	// @param	t SystemExceptionReplyBody value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.GIOP.SystemExceptionReplyBody t )
	{
		a.insert_Streamable( new org.omg.GIOP.SystemExceptionReplyBodyHolder( t ));
	}

	//
	// Extract SystemExceptionReplyBody from an any
	// @param	a an any
	// @return the extracted SystemExceptionReplyBody value
	//
	public static org.omg.GIOP.SystemExceptionReplyBody extract( org.omg.CORBA.Any a )
	{
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the SystemExceptionReplyBody TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "exception_id";
				_members[0].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "minor_code_value";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
				_members[2] = new org.omg.CORBA.StructMember();
				_members[2].name = "completion_status";
				_members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
				_tc = orb.create_struct_tc(id(),"SystemExceptionReplyBody",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the SystemExceptionReplyBody IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/GIOP/SystemExceptionReplyBody:1.0";

	//
	// Read SystemExceptionReplyBody from a marshalled stream
	// @param	istream the input stream
	// @return the readed SystemExceptionReplyBody value
	//
	public static org.omg.GIOP.SystemExceptionReplyBody read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.GIOP.SystemExceptionReplyBody new_one = new org.omg.GIOP.SystemExceptionReplyBody();

		new_one.exception_id = istream.read_string();
		new_one.minor_code_value = istream.read_ulong();
		new_one.completion_status = istream.read_ulong();

		return new_one;
	}

	//
	// Write SystemExceptionReplyBody into a marshalled stream
	// @param	ostream the output stream
	// @param	value SystemExceptionReplyBody value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.GIOP.SystemExceptionReplyBody value )
	{
		ostream.write_string(value.exception_id);
		ostream.write_ulong(value.minor_code_value);
		ostream.write_ulong(value.completion_status);
	}

}
