package org.omg.IIOP;

//
// Helper class for : ListenPoint
//
// @author OpenORB Compiler
//
public class ListenPointHelper
{

	//
	// Insert ListenPoint into an any
	// @param	a an any
	// @param	t ListenPoint value
	//
	public static void insert( org.omg.CORBA.Any a, org.omg.IIOP.ListenPoint t )
	{
		a.insert_Streamable( new org.omg.IIOP.ListenPointHolder( t ));
	}

	//
	// Extract ListenPoint from an any
	// @param	a an any
	// @return the extracted ListenPoint value
	//
	public static org.omg.IIOP.ListenPoint extract( org.omg.CORBA.Any a )
	{
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;
	private static boolean _working = false;

	//
	// Return the ListenPoint TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			synchronized(org.omg.CORBA.TypeCode.class) {
				if ( _tc != null )
					return _tc;
				if ( _working )
					return org.omg.CORBA.ORB.init().create_recursive_tc( id() );
				_working = true;
				org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
				org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

				_members[0] = new org.omg.CORBA.StructMember();
				_members[0].name = "host";
				_members[0].type = orb.get_primitive_tc( org.omg.CORBA.TCKind.tk_string );
				_members[1] = new org.omg.CORBA.StructMember();
				_members[1].name = "port";
				_members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ushort);
				_tc = orb.create_struct_tc(id(),"ListenPoint",_members);
				_working = false;
			}
		}
		return _tc;
	}

	//
	// Return the ListenPoint IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:omg.org/IIOP/ListenPoint:1.0";

	//
	// Read ListenPoint from a marshalled stream
	// @param	istream the input stream
	// @return the readed ListenPoint value
	//
	public static org.omg.IIOP.ListenPoint read( org.omg.CORBA.portable.InputStream istream )
	{
		org.omg.IIOP.ListenPoint new_one = new org.omg.IIOP.ListenPoint();

		new_one.host = istream.read_string();
		new_one.port = istream.read_ushort();

		return new_one;
	}

	//
	// Write ListenPoint into a marshalled stream
	// @param	ostream the output stream
	// @param	value ListenPoint value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, org.omg.IIOP.ListenPoint value )
	{
		ostream.write_string(value.host);
		ostream.write_ushort(value.port);
	}

}
